#include <stdio.h>
#include "dvd_reader.h"

using namespace std;

int main(int argc, char**argv)
{
    //dvd_read_domain_t domain_t = DVD_READ_TITLE_VOBS;
    if (argc ==5)
    {
        int titleNum, menuNum;
        char* pPath, *pDst;
        pPath = argv[1];
        pDst = argv[2];
        sscanf(argv[3], "%d", &titleNum);
        sscanf(argv[4], "%d", &menuNum);

        dvd_reader_t* pDvd = NULL;
        dvd_file_t* pFile = NULL;
        //const char* pPath = "/media/THE_THIN_BLUE_LINE_DISC2/";
        if ((pDvd = DVDOpen(pPath))!= NULL)
        {
            if ((pFile = DVDOpenSingleFile(pDvd, titleNum, menuNum))!= NULL)
            {
                ssize_t nFileSize = DVDFileSize(pFile);
                /*
                unsigned char pmd5[16];
                if (DVDDiscID(pDvd, pmd5) == 0)
                {
                    printf("discId=:");
                    for (int i = 0; i < 16; i ++)
                    {
                        printf("%x", pmd5[i]);
                    }
                    printf("\n");
                    char pVolId[32];
                    unsigned char pVolSetId[129];
                    if (DVDISOVolumeInfo(pDvd, pVolId, 32, pVolSetId, 128)== 0)
                    {
                        printf("fileSize=%d, volId=%s, volSetId=%s\n", nFileSize, pVolId, pVolSetId);
                    }
                }
                */
                unsigned char buffer[DVD_VIDEO_LB_LEN];
                char pFileName[1024];
                sprintf(pFileName, "%s/vts_%02d_%d.vob", pDst, titleNum, menuNum);
                FILE* pTargetFile = fopen(pFileName, "w");

                for (int i=0; i< nFileSize; i ++)
                {
                    if (DVDReadBlocks(pFile, i, 1, buffer) != 1)
                    {
                        break;
                    }
                    if (i % 10 == 0)
                    {
                        printf(".");
                    }
                    fwrite(buffer, 1,DVD_VIDEO_LB_LEN, pTargetFile);
                }
                fclose(pTargetFile);
                DVDCloseFile(pFile);
            }
            DVDClose(pDvd);
        }
    }
    else
    {
        printf("usage:%s dvdPath ripPath titleNumber menuNumber\n", argv[0]);
        printf("example:%s /media/DVD /home/user/movies 1 2\n", argv[0]);
        printf("which means rip DVD file VTS_01_2.vob from /media/DVd to directory /home/user/movies/VTS_01_2.vob\n");
    }
    return 0;
}
